## ros-kinetic-transmission-interface 0.13.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(transmission_interface)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS
  cmake_modules
  hardware_interface
  pluginlib
  roscpp
)

# Include a custom cmake file for TinyXML
find_package(TinyXML REQUIRED)

# Declare a catkin package
catkin_package(
  LIBRARIES
    ${PROJECT_NAME}_parser
    ${PROJECT_NAME}_loader
    ${PROJECT_NAME}_loader_plugins
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    pluginlib
    roscpp
  DEPENDS
    TinyXML
)

###########
## Build ##
###########

# Build
include_directories(include ${catkin_INCLUDE_DIRS} ${TinyXML_INCLUDE_DIRS})

# Transmission parser Library
add_library(${PROJECT_NAME}_parser
  src/transmission_parser.cpp include/transmission_interface/transmission_parser.h
)
target_link_libraries(${PROJECT_NAME}_parser ${catkin_LIBRARIES} ${TinyXML_LIBRARIES})


# Transmission loader library
add_library(${PROJECT_NAME}_loader
  src/transmission_loader.cpp           include/transmission_interface/transmission_loader.h
  src/transmission_interface_loader.cpp include/transmission_interface/transmission_interface_loader.h
)
target_link_libraries(${PROJECT_NAME}_loader
  ${PROJECT_NAME}_parser
  ${catkin_LIBRARIES}
  ${TinyXML_LIBRARIES})


add_library(${PROJECT_NAME}_loader_plugins
  src/simple_transmission_loader.cpp                      include/transmission_interface/simple_transmission_loader.h
  src/differential_transmission_loader.cpp                include/transmission_interface/differential_transmission_loader.h
  src/four_bar_linkage_transmission_loader.cpp            include/transmission_interface/four_bar_linkage_transmission_loader.h
  src/joint_state_interface_provider.cpp                  include/transmission_interface/joint_state_interface_provider.h
  src/position_joint_interface_provider.cpp               include/transmission_interface/position_joint_interface_provider.h
  src/velocity_joint_interface_provider.cpp               include/transmission_interface/velocity_joint_interface_provider.h
  src/effort_joint_interface_provider.cpp                 include/transmission_interface/effort_joint_interface_provider.h
  src/bidirectional_position_joint_interface_provider.cpp include/transmission_interface/bidirectional_position_joint_interface_provider.h
  src/bidirectional_velocity_joint_interface_provider.cpp include/transmission_interface/bidirectional_velocity_joint_interface_provider.h
  src/bidirectional_effort_joint_interface_provider.cpp   include/transmission_interface/bidirectional_effort_joint_interface_provider.h)
target_link_libraries(${PROJECT_NAME}_loader_plugins ${PROJECT_NAME}_loader)


#############
## Install ##
#############

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(TARGETS ${PROJECT_NAME}_parser
                ${PROJECT_NAME}_loader
                ${PROJECT_NAME}_loader_plugins
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(FILES ros_control_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)

  find_package(Boost REQUIRED COMPONENTS system thread)
  find_package(catkin REQUIRED COMPONENTS resource_retriever roscpp)

  catkin_add_gtest(simple_transmission_test test/simple_transmission_test.cpp)
  target_link_libraries(simple_transmission_test ${Boost_LIBRARIES})

  catkin_add_gtest(differential_transmission_test test/differential_transmission_test.cpp)
  target_link_libraries(differential_transmission_test ${Boost_LIBRARIES})

  catkin_add_gtest(four_bar_linkage_transmission_test test/four_bar_linkage_transmission_test.cpp)
  target_link_libraries(four_bar_linkage_transmission_test ${Boost_LIBRARIES})

  catkin_add_gtest(transmission_interface_test test/transmission_interface_test.cpp)
  target_link_libraries(transmission_interface_test ${TinyXML_LIBRARIES} ${catkin_LIBRARIES})

  catkin_add_gtest(transmission_parser_test test/transmission_parser_test.cpp)
  target_link_libraries(transmission_parser_test ${PROJECT_NAME}_parser ${catkin_LIBRARIES})

  catkin_add_gtest(simple_transmission_loader_test test/simple_transmission_loader_test.cpp)
  target_link_libraries(simple_transmission_loader_test ${PROJECT_NAME}_parser ${catkin_LIBRARIES})

  catkin_add_gtest(differential_transmission_loader_test test/differential_transmission_loader_test.cpp)
  target_link_libraries(differential_transmission_loader_test ${PROJECT_NAME}_parser ${catkin_LIBRARIES})

  catkin_add_gtest(four_bar_linkage_transmission_loader_test test/four_bar_linkage_transmission_loader_test.cpp)
  target_link_libraries(four_bar_linkage_transmission_loader_test ${PROJECT_NAME}_parser ${catkin_LIBRARIES})

  catkin_add_gtest(transmission_interface_loader_test test/transmission_interface_loader_test.cpp)
  target_link_libraries(transmission_interface_loader_test ${PROJECT_NAME}_parser
                                                          transmission_interface_loader
                                                          ${catkin_LIBRARIES})
endif()

=== debian/changelog ===
ros-kinetic-transmission-interface (0.13.5-1xenial) xenial; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 09 Feb 2020 00:00:00 -0000

ros-kinetic-transmission-interface (0.13.4-1xenial) xenial; urgency=high

  * add minimum required pluginlib version
  * Contributors: Mikael Arguedas

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 12 Jan 2020 00:00:00 -0000

ros-kinetic-transmission-interface (0.13.3-1xenial) xenial; urgency=high

  * Introduce shared_ptr typedefs
  * Update maintainers
  * Fix catkin_lint errors and warnings
  * fix license string
  * Update transmission parser to parse the joint role
  * Contributors: Bence Magyar, Patrick Holthaus, jlack1987

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 25 Apr 2018 23:00:00 -0000

ros-kinetic-transmission-interface (0.13.2-1xenial) xenial; urgency=high

  * migrate to new class list macros header
  * migrate classloader headers
  * Contributors: Mathias Lüdtke

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 15 Apr 2018 23:00:00 -0000

ros-kinetic-transmission-interface (0.13.1-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 25 Mar 2018 23:00:00 -0000

ros-kinetic-transmission-interface (0.13.0-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sat, 23 Dec 2017 00:00:00 -0000

ros-kinetic-transmission-interface (0.12.0-1xenial) xenial; urgency=high

  * Add unit tests for new bidirectional joint interface providers
  * Add bidirectional joint interface providers
  * Add inverse transmission interfaces to TransmissionLoaderData
  * Contributors: Jordan Lack

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 04 Aug 2017 23:00:00 -0000

ros-kinetic-transmission-interface (0.11.5-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Tue, 27 Jun 2017 23:00:00 -0000

ros-kinetic-transmission-interface (0.11.4-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Tue, 14 Feb 2017 00:00:00 -0000

ros-kinetic-transmission-interface (0.11.3-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Wed, 07 Dec 2016 00:00:00 -0000

ros-kinetic-transmission-interface (0.11.2-1xenial) xenial; urgency=high

  * Add Enrique and Bence to maintainer list
  * Clean up export leftovers from rosbuild
  * Convert to format2, fix dependency in cmake
  * Contributors: Bence Magyar

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 28 Nov 2016 00:00:00 -0000

ros-kinetic-transmission-interface (0.11.1-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Wed, 17 Aug 2016 23:00:00 -0000

ros-kinetic-transmission-interface (0.11.0-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 22 May 2016 23:00:00 -0000

ros-kinetic-transmission-interface (0.10.1-1xenial) xenial; urgency=high

  * Remove control_toolbox dependency. Fix thread linking error coming from removal of dependency.
  * Contributors: Bence Magyar

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 22 Apr 2016 23:00:00 -0000

ros-kinetic-transmission-interface (0.10.0-1xenial) xenial; urgency=high

  * Allow loading transmissions from a vector of TransmissionInfo instances.
  * Address -Wunused-parameter warnings
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 20 Nov 2015 00:00:00 -0000

ros-kinetic-transmission-interface (0.9.3-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 04 May 2015 23:00:00 -0000

ros-kinetic-transmission-interface (0.9.2-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 03 May 2015 23:00:00 -0000

ros-kinetic-transmission-interface (0.9.1-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 03 Nov 2014 00:00:00 -0000

ros-kinetic-transmission-interface (0.9.0-1xenial) xenial; urgency=high

  * Buildsystem and documentation fixes
  * Contributors: Adolfo Rodriguez Tsouroukdissian, shadowmanos

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-kinetic-transmission-interface (0.8.2-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Tue, 24 Jun 2014 23:00:00 -0000

ros-kinetic-transmission-interface (0.8.1-1xenial) xenial; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 23 Jun 2014 23:00:00 -0000

ros-kinetic-transmission-interface (0.8.0-1xenial) xenial; urgency=high

  * Add developer documentation.
  * Build script fixes.
    - Add missing libraries to catkin_package call.
    - Gate tests with CATKIN_ENABLE_TESTING.
    - Add missing files to install target.
  * Fix possible memory corruption in tests.
  * Perform sanity checks on members, not parameters.
    - The result is the same, but this is more uniform with the rest of the code.
  * Enable joint reduction spec for 4-bar linkages.
    - As in the differential transmission, it's convenient to specify an additional
    mechanical reduction on the joint output. This is especially convenient for
    flipping the rotation direction of a joint (negative reduction value).
    - Update URDF loader.
    - Update documentation and tests.
  * Trivial, cosmetic fixes.
  * C++11 compatibility fixes.
  * Fix resource check for multi-dof transmisisons.
  * Efficiency fix.
    - cppcheck flagged a [passedByValue] warning. Using const references instead.


=== debian/control ===
Source: ros-kinetic-transmission-interface
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libtinyxml-dev, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-hardware-interface, ros-kinetic-pluginlib (>= 1.11.2), ros-kinetic-resource-retriever, ros-kinetic-roscpp, ros-kinetic-rosunit
Homepage: https://github.com/ros-controls/ros_control/wiki
Standards-Version: 3.9.2

Package: ros-kinetic-transmission-interface
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtinyxml-dev, ros-kinetic-pluginlib (>= 1.11.2), ros-kinetic-roscpp
Description: Transmission Interface.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-transmission-interface//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
